<%@ Page Language="c#" CodeBehind="AdminSettings.aspx.cs" AutoEventWireup="True" Inherits="JitbitCRM.AdminSettings" MasterPageFile="JitbitCRMMaster.Master" %>
<%@ Import Namespace="Jitbit.Utils" %>
<%@ Import Namespace="JitbitCRM.BusinessLayer" %>
<asp:Content ContentPlaceHolderID="ContentPlaceHolder1" ID="Content1" runat="server">
	<h2 class="breadcrumbs"><a href="Admin.aspx">Administration</a> &raquo;
		<asp:Label ID="lblsettings" runat="server" EnableViewState="False" meta:resourcekey="lblSettingsResource1">Settings</asp:Label></h2>
				
	<script src="js/colorpicker.js" type="text/javascript"></script>
	<p>		
	<asp:Button ID="btnSaveTop"  runat="server" Text="Save changes"
		OnClick="btnSave_Click" meta:resourcekey="btnSaveResource1" EnableViewState="false">
	</asp:Button>
	</p>	
				
	<div runat="server" id="divTestEmail" visible="false" enableviewstate="false"></div>                
	
<table class="outerroundedbox admintable grey">
<colgroup><col style="width:20%"><col style="width:80%"></colgroup> 
	<tr><th colspan="2">
		<b><asp:Label ID="lblDesign" runat="server" EnableViewState="false">Design</asp:Label></b>
		<a href="javascript:DisplayHelp(' <%=HelpFilePath()%>')">..?</a>
	</th></tr>
	<tr>
	<td align="right">Header background color:<br />(dark tones are highly recommended)</td>
	<td>
		#<asp:TextBox ID="tbHeaderBGColor" runat="server"></asp:TextBox><a href="javascript:showColorGrid2('none', '<%=tbHeaderBGColor.ClientID %>')">...</a><span id="colorpicker201" class="colorpicker201"></span>
		<asp:RegularExpressionValidator ID="rgxvHeaderColor" runat="server" ValidationExpression="[0-9A-Fa-f]{6}" ControlToValidate="tbHeaderBGColor" Display="Dynamic" ErrorMessage="Wrong format"></asp:RegularExpressionValidator>
	</td>
	</tr>
	<tr>
	<td align="right">Menu-bar background color:</td>
	<td>
		#<asp:TextBox ID="tbMenuBarBGColor" runat="server"></asp:TextBox><a href="javascript:showColorGrid2('none', '<%=tbMenuBarBGColor.ClientID %>')">...</a>
		<asp:RegularExpressionValidator ID="RegularExpressionValidator1" runat="server" ValidationExpression="[0-9A-Fa-f]{6}" ControlToValidate="tbMenuBarBGColor" Display="Dynamic" ErrorMessage="Wrong format"></asp:RegularExpressionValidator>
	</td>
	</tr>
	<tr valign="top">
	<td align="right">Logo image (60px height, <b>PNG only</b>):<br />Transparent background is <b>highly</b> recommended.</td>
	<td>
		<asp:FileUpload ID="fileLogo" runat="server" /><br />
		<% if (Settings.LogoImage != null) { %>
			<img style="padding:5px;margin-top:5px;" class="adminlogo" src="LogoImage.ashx" alt="logo" />
		<% } %>
	</td>
	</tr>
	<tr><td></td><td><asp:Button ID="btnResetDesign" runat="server" Text="reset to defaults" CausesValidation="false" onclick="btnResetDesign_Click" /></td></tr>
	<tr><td></td><td>
	<i>After updating the design settings you may have to open the homepage and hit F5 ("Refresh") several times in your browser to clear the browser's cache.</i>
	</td></tr>

	<tr><td colspan="2" style="border-bottom:1px solid #D2D5D7"></td></tr>
	<tr>
		<td align="right">CRM title (displayed on top):</td>
		<td><asp:TextBox ID="tbInstanceDescr" runat="server" EnableViewState="False"></asp:TextBox></td>
	</tr>
	<tr id="trInstanceName" runat="server" enableviewstate="false">
		<td align="right">CRM URL:</td>
		<td>https://<asp:TextBox ID="tbInstanceName" runat="server" EnableViewState="False"></asp:TextBox>.jitbit.com/crm</td>
	</tr>
	<tr id="trInstanceDomain" runat="server" enableviewstate="false" valign="top">
		<td align="right">Custom domain:</td>
		<td>
			http://<asp:TextBox ID="tbInstanceDomain" runat="server" EnableViewState="False"></asp:TextBox>/crm
			<div class="grey">leave blank to disable this feature</div>
			<a href="http://www.jitbit.com/hosted-crm/articles/hosted-crm-custom-domain/" target="_blank">more info about custom domains</a>
		</td>
	</tr>
</table>
<table class="outerroundedbox admintable grey" >
<colgroup><col style="width:20%"><col style="width:80%"></colgroup> 
	<tr>
		<th colspan="2">
			<b><asp:Label runat="server" ID="lblVarious" EnableViewState="False" meta:resourcekey="lblVariousResource1" Text="Various settings"></asp:Label></b>
			<a href="javascript:DisplayHelp(' <%=HelpFilePath()%>')">..?</a>
		</th>
	</tr>
	<tr>
		<td colspan="2">
			<asp:CheckBox ID="chkAllowUserRegistration" runat="server" Text="Allow new users to register themselves (uncheck if you want to create all new users MANUALLY)" meta:resourcekey="chkAllowUserRegistrationResource1" /><br />
			<asp:CheckBox ID="cbShowTagListAsMenu" runat="server" Text="Show tag-menu instead of the tag-cloud" meta:resourcekey="cbShowTagListAsMenuResource1" /><br />
			<asp:CheckBox ID="cbShowEntitiesToSubscribersOnly" runat="server" Text="Security: show companies/contacts/projects to subscribers and assigned-users only" />
		</td>
	</tr>
	<tr>
		<td align="right">
			<asp:Label ID="lblMaxAttachSize" runat="server" EnableViewState="False" meta:resourcekey="lblMaxAttachSizeResource1">Maximum attachment filesize (in kb):</asp:Label>
		</td>
		<td>
			<asp:TextBox ID="tbMaxAttachSize" runat="server" EnableViewState="False"></asp:TextBox>
		</td>
	</tr>
	<tr>
		<td align="right">
			<asp:Label ID="lblAutoLoginSharedSecret" AssociatedControlID="tbAutoLoginSharedSecret" runat="server" EnableViewState="False" meta:resourcekey="lblAutoLoginSharedSecretResource1">Shared secret for remote authentication:</asp:Label>
		</td>
		<td>
			<asp:TextBox ID="tbAutoLoginSharedSecret" MaxLength="20" runat="server" EnableViewState="False"/><button type="button" onclick="$('#<%= tbAutoLoginSharedSecret.ClientID %>').val(GeneratePassword(12))">generate</button>
		</td>
	</tr>
	<tr><td></td>
		<td>
			<i class="grey"><asp:Label ID="lblAutoLoginSharedSecretHelp" runat="server" EnableViewState="False" meta:resourcekey="lblAutoLoginSharedSecretHelpResource1">Used for automatic user sign-in. See the manual for more info about the remote authentication API.</asp:Label></i>
		</td>
	</tr>
	<tr>
		<td align="right">
			<asp:Label ID="lblServerTimeOffset" runat="server" EnableViewState="False" meta:resourcekey="lblServerTimeOffsetResource1">Server time offset (for example: if your server is in New York-USA, but your CRM is French, you might want to add a 6 hours offset (cause when it's 1:00 in NY it is 7:00 in Paris). This can be a negative value. Integer.</asp:Label>
		</td>
		<td><asp:TextBox ID="tbServerTimeOffset" runat="server" EnableViewState="False"/></td>
	</tr>
</table>
<table class="outerroundedbox admintable grey">
<colgroup><col style="width:20%"><col style="width:80%"></colgroup> 
<tr>
	<th colspan="2">
		<asp:Label runat="server" ID="Label1" EnableViewState="False" meta:resourcekey="Label1Resource1" Text="Outgoing email settings"></asp:Label>
		<a href="javascript:DisplayHelp(' <%=HelpFilePath()%>')">..?</a>
	</th>
</tr>
<tr>
	<td colspan="2">
	<div id="divDefaultSMTP" runat="server" enableviewstate="false">
		<asp:CheckBox ID="cbUseDefaultSMTP" runat="server" Text="Use Jitbit's SMTP server" meta:resourcekey="cbDefaultSMTPResource1" onclick="EnableDisableSMTPFields(this.checked);" />
		<script type="text/javascript">
			function EnableDisableSMTPFields(value) {
				try {
					document.getElementById("<%= tbFrom.ClientID %>").disabled = value;
					document.getElementById("<%= tbSMTPServer.ClientID %>").disabled = value;
					document.getElementById("<%= tbSMTPPort.ClientID %>").disabled = value;
					document.getElementById("<%= cbSmtpAuth.ClientID %>").disabled = value;
					document.getElementById("<%= tbSMTPUser.ClientID %>").disabled = value;
					document.getElementById("<%= tbSMTPPsw.ClientID %>").disabled = value;
					document.getElementById("<%= cbSMTPUseSSL.ClientID %>").disabled = value;

					$("label[for='<%= cbSmtpAuth.ClientID %>']").attr("class", strClassName);
					$("label[for='<%= cbSMTPUseSSL.ClientID %>']").attr("class", strClassName);
				} catch (e) { }
			}
			function InitFields() {
				EnableDisableSMTPFields(document.getElementById("<%=cbUseDefaultSMTP.ClientID %>").checked);
			}
			window.onload = InitFields;
		</script>
	</div>
	</td>
</tr>
<tr>
	<td align="right">
		<asp:Label runat="server" ID="lblFrom" EnableViewState="False" meta:resourcekey="lblFromResource1"
			Text='"From" email-address (eg. "robot@myserver.com"):'></asp:Label>
	</td>
	<td>
		<asp:TextBox ID="tbFrom" runat="server"></asp:TextBox>
	</td>
</tr>
<tr>
	<td align="right">
		<asp:Label runat="server" ID="lblReplyTo" EnableViewState="False" meta:resourcekey="lblReplyToResource1"
			Text='"Reply-To" email-address (eg. "robot@myserver.com"):'></asp:Label>
	</td>
	<td>
		<asp:TextBox ID="tbReplyTo" runat="server"></asp:TextBox>
	</td>
</tr>
<tr>
<td></td>
<td><i>It is recommended to set the 'Reply-To' address to the same email address as in the email-checker below.</i></td>
</tr>
<tr>
	<td align="right">
		<asp:Label runat="server" ID="lblSMTPServer" EnableViewState="False" meta:resourcekey="lblSMTPServerResource1"
			Text='SMTP server address (eg. "smtp.server.com"):'></asp:Label>
	</td>
	<td>
		<asp:TextBox ID="tbSMTPServer" runat="server"></asp:TextBox>
	</td>
</tr>
<tr>
	<td align="right">
		<asp:Label runat="server" ID="lblSMTPPort" EnableViewState="False" meta:resourcekey="lblSMTPPortResource1"
			Text='SMTP server port (eg. "25"):'></asp:Label>
	</td>
	<td>
		<asp:TextBox ID="tbSMTPPort" runat="server"></asp:TextBox><span class="grey"> (25, 465, 587 etc.)</span>
	</td>
</tr>
<tr>
	<td colspan="2">
		<asp:CheckBox ID="cbSmtpAuth" runat="server" Text="SMTP server requires authentication" meta:resourcekey="cbSmtpAuthResource1"></asp:CheckBox>
	</td>
</tr>
<tr>
	<td align="right">
		<asp:Label runat="server" ID="lblSMTPUser" EnableViewState="False" meta:resourcekey="lblSMTPUserResource1" Text="SMTP username:"></asp:Label>
	</td>
	<td>
		<asp:TextBox ID="tbSMTPUser" runat="server"></asp:TextBox>
	</td>
</tr>
<tr>
	<td align="right">
		<asp:Label runat="server" ID="lblSMTPPassword" EnableViewState="False" meta:resourcekey="lblSMTPPasswordResource1"
			Text="SMTP password:"></asp:Label>
	</td>
	<td>
		<asp:TextBox ID="tbSMTPPsw" runat="server" TextMode="Password"></asp:TextBox>
	</td>
</tr>
<tr><td colspan="2">
	<asp:CheckBox ID="cbSMTPUseSSL" runat="server" Text="Use SSL to connect to the SMTP server" meta:resourcekey="cbSMTPUseSSLResource1"></asp:CheckBox>
</td></tr>
<tr><td></td>
<td>
	<asp:Button ID="btnTestSMTP" CausesValidation="false" runat="server" Text="Test SMTP settings..." onclick="btnTestSMTP_Click" OnClientClick="return PromptForAddress();" />
	<asp:HiddenField ID="hiddenTestEmail" runat="server" EnableViewState="false" />
</td></tr>
</table>


<table class="admintable outerroundedbox grey">
<colgroup><col style="width:20%"><col style="width:80%"></colgroup> 
<tr><th colspan="2">
	<asp:Label runat="server" ID="lblIncomingHandler" EnableViewState="False" meta:resourcekey="lblIncomingHandlerResource1" Text="Incoming mail-handler settings"/>
	<a href="javascript:DisplayHelp('<%=HelpFilePath()%>#email_incoming')">..?</a>
</th></tr>
<tr>
	<td colspan="2">
		<asp:Label runat="server" ID="lblIcomingPrompt" EnableViewState="False" meta:resourcekey="lblIcomingPromptResource1" Text='"Incoming mail-handler" periodically checks the specified email address via POP or IMAP (it could be your company general email address like "info@mycompany.com") and imports incoming email-messages into CRM, to the appropriate Company or Contact log. A Company or Contact to add messages to, are detected by the message email-address. If no Company or Contact is found - either a news Contact is created, or the email is not being imported into CRM (see the next setting). Please note: the email is deleted from the POP server after improting into CRM.'/>

		<%-- for hosted verison only --%>
		<% if (Instance.CurrentInstanceID != 0) { %>
			<br /><br />We've already created an email address for you - <b>crm@<%= Instance.CurrentInstanceName %>.jitbit.com</b>.
			All messages sent to this mailbox will be imported into the CRM system. You can specify a different incoming email below.
		<% } %>
	</td>
</tr>

<tr>
	<td colspan="2">
		<asp:CheckBox ID="cbMailCheckerEnabled" runat="server" Text="Enable automatic email checker" meta:resourcekey="cbMailCheckerEnabledResource1"/>
	</td>
</tr>
<tr>
	<td colspan="2">
		<asp:CheckBox ID="cbMailCheckerAllowUnregisteredContacts" runat="server" Text="Allow emails from unregistred contacts (if an email comes-in from an unknown address - a new contact will be created)" />
	</td>
</tr>
<tr>
	<td align="right">
		<asp:Label runat="server" ID="lblInterval" EnableViewState="False" meta:resourcekey="lblIntervalResource1" Text="Time interval (in minutes, 10 recommended):"/>
	</td>
	<td><asp:TextBox ID="tbMailCheckerInterval" runat="server"/></td>
</tr>
<tr>
	<td align="right">
		<asp:Label runat="server" ID="lblPOPAddress" EnableViewState="False" meta:resourcekey="lblPOPAddressResource1" Text='Mail-server address (eg. "pop.server.com"):'/>
	</td>
	<td><asp:TextBox ID="tbPOPServer" runat="server"/></td>
</tr>
<tr>
	<td align="right">
		<asp:Label runat="server" ID="lblPOPPort" EnableViewState="False" meta:resourcekey="lblPOPPortResource1" Text='Mail-server port (eg. "110"):'/>
	</td>
	<td><asp:TextBox ID="tbPOPPort" runat="server"/></td>
</tr>
<tr>
	<td align="right">
		<asp:Label runat="server" ID="lblPOPLogin" EnableViewState="False" meta:resourcekey="lblPOPLoginResource1" Text='Mail-server login (eg. "support@myserver.com"):'/>
	</td>
	<td><asp:TextBox ID="tbPOPLogin" runat="server"/></td>
</tr>
<tr>
	<td align="right">
		<asp:Label runat="server" ID="lblPOPPassword" EnableViewState="False" meta:resourcekey="lblPOPPasswordResource1" Text='Mail-server password (eg. "support@myserver.com"):'/>
	</td>
	<td><asp:TextBox ID="tbPOPPassword" runat="server" TextMode="Password"/></td>
</tr>
<tr>
	<td colspan="2">
		<asp:CheckBox ID="cbMailCheckerUseSSL" runat="server" Text="Use SSL to connect to the Mail server" meta:resourcekey="cbMailCheckerUseSSLResource1"/>
	</td>
</tr>
<tr>
	<td colspan="2">
		<asp:CheckBox ID="cbMailCheckerIsImap" runat="server" Text="Use IMAP instead of POP"/>
	</td>
</tr>
<tr><td></td>
<td>
	<asp:Button ID="btnTestPOP" CausesValidation="false" runat="server" Text="Test Mail Settings..." CssClass="gradientbg" onclick="btnTestPOP_Click" />
</td>
</tr>
</table>


<table class="outerroundedbox admintable grey">
<colgroup><col style="width:20%"><col style="width:80%"></colgroup> 
<tr><th>
	Jitbit Helpdesk integration (optional)
</th></tr>
<tr><td>
	<table cellpadding="4">
		<tr>
			<td align="right">
				<asp:Label runat="server" ID="lblHDRootUrl" AssociatedControlID="tbHDRootUrl" EnableViewState="False" meta:resourcekey="lblHDRootUrl1" Text="Jitbit Helpdesk root URL" />
			</td>
			<td><asp:TextBox ID="tbHDRootUrl" runat="server" EnableViewState="False" /></td>
		</tr> 
		<tr><td></td>
			<td>
				<i class="grey">Example - <u>http://mysite/helpdesk/</u> or <u>http://acme.jitbit.com/helpdesk/</u></i>
			</td>
		</tr>
		<tr>
			<td align="right">
				<asp:Label ID="lblHDSharedKey" runat="server" AssociatedControlID="tbHDSharedKey" EnableViewState="False" meta:resourcekey="lblHDSharedKey1" Text="Jitbit Helpdesk shared key" />
			</td>
			<td><asp:TextBox ID="tbHDSharedKey" runat="server" EnableViewState="False" /></td>
		</tr>
		<tr><td></td>
			<td>
				<i class="grey">The "shared secret key" specified in Jitbit Helpdesk</i>
			</td>
		</tr>
		</table>
</td></tr></table>


<asp:Button ID="btnSave" runat="server" Text="Save changes"
	OnClick="btnSave_Click" meta:resourcekey="btnSaveResource1" EnableViewState="false">
</asp:Button>
<script type="text/javascript" src="js/passwordgen.js"></script>
<script type="text/javascript">
	function PromptForAddress() {
		var emailAddr = prompt("Enter email to send the test message to", "info@jitbit.com");
		if (emailAddr == null || emailAddr == "") return false;
		document.getElementById("<%= hiddenTestEmail.ClientID %>").value = emailAddr;
		return true;
	}
</script>
</asp:Content>
