--the script checks the database format
--and updates it to the latest version if necessary
--run it against the CRM's database to upgrade it!


--nvarchar
alter table crmCompanies alter column [Name] nvarchar(500) NOT NULL
alter table crmCompanies alter column Address1 nvarchar(1000) NULL
alter table crmCompanies alter column Address2 nvarchar(1000) NULL
alter table crmCompanies alter column City nvarchar(200) NULL
alter table crmCompanies alter column StateRegion nvarchar(200) NULL
alter table crmCompanies alter column Country nvarchar(200) NULL

alter table crmContacts alter column FirstName nvarchar(200) NOT NULL
alter table crmContacts alter column LastName nvarchar(200) NOT NULL
alter table crmContacts alter column Address1 nvarchar(1000) NOT NULL
alter table crmContacts alter column Address2 nvarchar(1000) NOT NULL
alter table crmContacts alter column City nvarchar(200) NOT NULL
alter table crmContacts alter column Country nvarchar(200) NOT NULL

--now changing to nvarchar column that have default constraint
declare @defName sysname, @sql nvarchar(1000)
--crmUsers.FirstName
select @defname = d.name from sys.tables t
join sys.default_constraints d on d.parent_object_id = t.object_id
join sys.columns c on c.object_id = t.object_id and c.column_id = d.parent_column_id
where t.name = 'crmUsers' and c.name = 'FirstName'
if not @defName is null begin
	set @sql = N'ALTER TABLE crmUsers DROP Constraint ' + @defName
	exec sp_executesql @sql
end
alter table crmUsers alter column FirstName nvarchar(255) NOT NULL
alter table crmUsers WITH NOCHECK add constraint DF_crmUsers_FirstName DEFAULT ('') FOR FirstName
--crmUsers.LastName
select @defname = d.name from sys.tables t
join sys.default_constraints d on d.parent_object_id = t.object_id
join sys.columns c on c.object_id = t.object_id and c.column_id = d.parent_column_id
where t.name = 'crmUsers' and c.name = 'LastName'
if not @defName is null begin
	set @sql = N'ALTER TABLE crmUsers DROP Constraint ' + @defName
	exec sp_executesql @sql
end
alter table crmUsers alter column LastName nvarchar(255) NOT NULL
alter table crmUsers WITH NOCHECK add constraint DF_crmUsers_LastName DEFAULT ('') FOR LastName
--crmUsers.Notes
select @defname = d.name from sys.tables t
join sys.default_constraints d on d.parent_object_id = t.object_id
join sys.columns c on c.object_id = t.object_id and c.column_id = d.parent_column_id
where t.name = 'crmUsers' and c.name = 'Notes'
if not @defName is null begin
	set @sql = N'ALTER TABLE crmUsers DROP Constraint ' + @defName
	exec sp_executesql @sql
end
alter table crmUsers alter column Notes nvarchar(255) NOT NULL
alter table crmUsers WITH NOCHECK add constraint DF_crmUsers_Notes DEFAULT ('') FOR Notes


alter table crmUsers alter column Location nvarchar(1000) NULL

--adding color settings columns to "Setttings"
if not exists (select * from syscolumns where id=object_id('crmSettings') and name='HeaderBGColor')
begin
	  ALTER TABLE crmSettings ADD HeaderBGColor char(6) NOT NULL DEFAULT('34383E')
	  ALTER TABLE crmSettings ADD MenuBarBGColor char(6) NOT NULL DEFAULT('FF7700')
	  ALTER TABLE crmSettings ADD LogoImage [image] NULL
end

--default smtp
if not exists (select * from syscolumns where id=object_id('crmSettings') and name='UseDefaultSmtp')
begin
	  ALTER TABLE crmSettings ADD UseDefaultSmtp bit NOT NULL DEFAULT 0
end
GO

--adding comment-type column to "comments"
if not exists (select * from syscolumns where id=object_id('crmComments') and name='CommentType')
begin
	  ALTER TABLE crmComments ADD CommentType int NOT NULL DEFAULT(1)
end

--adding "avatars" to conacts and companies
IF NOT EXISTS (SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'crmCompanyImages') AND type in (N'U'))
BEGIN
	CREATE TABLE crmCompanyImages (
		CompanyID int NOT NULL PRIMARY KEY,
		ImageFileName nvarchar(100) NOT NULL,
		ImageFileData [image] NOT NULL
	)
END
IF NOT EXISTS (SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'crmContactImages') AND type in (N'U'))
BEGIN
	CREATE TABLE crmContactImages (
		ContactID int NOT NULL PRIMARY KEY,
		ImageFileName nvarchar(100) NOT NULL,
		ImageFileData [image] NOT NULL
	)
END

--adding ServerTimeOffset to crmSettings
if not exists (select * from syscolumns where id=object_id('crmSettings') and name='ServerTimeOffset')
begin
	ALTER TABLE crmSettings ADD ServerTimeOffset int NOT NULL DEFAULT 0
end

--adding Title to crmContacts
if not exists (select * from syscolumns where id=object_id('crmContacts') and name='Title')
begin
	ALTER TABLE crmContacts ADD Title nvarchar(200) NULL
end

--adding SendReminder to crmTasks
if not exists (select * from syscolumns where id=object_id('crmTasks') and name='SendReminder')
begin
	ALTER TABLE crmTasks ADD SendReminder bit NOT NULL DEFAULT 0
end

--adding "MenuBarTabColor" to "Setttings"
if not exists (select * from syscolumns where id=object_id('crmSettings') and name='MenuBarTabColor')
begin
	  ALTER TABLE crmSettings ADD MenuBarTabColor char(6) NOT NULL DEFAULT('D5783A')
end

--converting from nvarchar(4000) to Nvarchar(MAX)
alter table crmContacts alter column Comments nvarchar(MAX) NULL
alter table crmCompanies alter column Comments nvarchar(MAX) NULL
alter table crmComments alter column Body nvarchar(MAX) NOT NULL
GO

--adding mailchecker columns to settings
if not exists (select * from syscolumns where id=object_id('crmSettings') and name='MailCheckerEnabled')
begin
	ALTER TABLE crmSettings ADD MailCheckerEnabled bit NOT NULL DEFAULT (0)
	ALTER TABLE crmSettings ADD MailCheckerInterval int NOT NULL DEFAULT (600)
	ALTER TABLE crmSettings ADD MailCheckerPOPServer varchar (50) NULL
	ALTER TABLE crmSettings ADD MailCheckerPOPPort int NOT NULL DEFAULT (110)
	ALTER TABLE crmSettings ADD MailCheckerPOPLogin varchar (50) NULL
	ALTER TABLE crmSettings ADD MailCheckerPOPPassword varchar (50) NULL
	ALTER TABLE crmSettings ADD MailCheckerUseSSL bit NOT NULL DEFAULT (0)
end
GO

--adding "viewhistory" tables
IF NOT EXISTS (SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'crmContactViewHistory') AND type in (N'U'))
BEGIN
	CREATE TABLE crmContactViewHistory (
		UserID int NOT NULL,
		ContactID int NOT NULL,
		ViewDate datetime NOT NULL DEFAULT (getdate())
	)
	ALTER TABLE crmContactViewHistory WITH NOCHECK ADD CONSTRAINT [PK_crmContactViewHistory] PRIMARY KEY CLUSTERED (
		UserID,
		ContactID
	)
	CREATE TABLE crmCompanyViewHistory (
		UserID int NOT NULL,
		CompanyID int NOT NULL,
		ViewDate datetime NOT NULL DEFAULT (getdate())
	)
	ALTER TABLE crmCompanyViewHistory WITH NOCHECK ADD CONSTRAINT [PK_crmCompanyViewHistory] PRIMARY KEY CLUSTERED (
		UserID,
		CompanyID
	)
END
GO

--adding "projects" tables
IF NOT EXISTS (SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'crmProjects') AND type in (N'U'))
BEGIN
	CREATE TABLE crmProjects (
		[ProjectID] [int] IDENTITY (1, 1) NOT NULL PRIMARY KEY,
		InstanceID int NOT NULL DEFAULT(0),
		[Name] nvarchar(500) NOT NULL,
		IsClosed bit NOT NULL DEFAULT(0)
	)
	CREATE TABLE crmProjectCompanies (
		ProjectID int NOT NULL,
		CompanyID int NOT NULL
	)
	ALTER TABLE crmProjectCompanies WITH NOCHECK ADD CONSTRAINT [PK_crmProjectCompanies] PRIMARY KEY CLUSTERED (
		ProjectID,
		CompanyID
	)
	CREATE TABLE crmProjectContacts (
		ProjectID int NOT NULL,
		ContactID int NOT NULL
	)
	ALTER TABLE crmProjectContacts WITH NOCHECK ADD CONSTRAINT [PK_crmProjectContacts] PRIMARY KEY CLUSTERED (
		ProjectID,
		ContactID
	)
	CREATE TABLE crmProjectViewHistory (
		UserID int NOT NULL,
		ProjectID int NOT NULL,
		ViewDate datetime NOT NULL DEFAULT (getdate())
	)
	ALTER TABLE crmProjectViewHistory WITH NOCHECK ADD CONSTRAINT [PK_crmProjectViewHistory] PRIMARY KEY CLUSTERED (
		UserID,
		ProjectID
	)
end
--adding "projectID" to comments & tasks
if not exists (select * from syscolumns where id=object_id('crmComments') and name='ProjectID')
begin
	ALTER TABLE crmComments ADD ProjectID int NULL
end
if not exists (select * from syscolumns where id=object_id('crmTasks') and name='ProjectID')
begin
	ALTER TABLE crmTasks ADD ProjectID int NULL
end

--addning "latestcoment" fields
if not exists (select * from syscolumns where id=object_id('crmCompanies') and name='LatestCommentID')
begin
	ALTER TABLE crmCompanies ADD LatestCommentID int NULL
	ALTER TABLE crmProjects ADD LatestCommentID int NULL
	ALTER TABLE crmContacts ADD LatestCommentID int NULL
end
GO

update crmCompanies set LatestCommentID = 
	(select MAX(crmComments.CommentID)
	from crmComments
	where crmComments.CompanyID=crmCompanies.CompanyID)
from crmCompanies
where LatestCommentID is null

update crmContacts set LatestCommentID = 
	(select MAX(crmComments.CommentID)
	from crmComments
	where crmComments.ContactID=crmContacts.ContactID)
from crmContacts
where LatestCommentID is null

update crmProjects set LatestCommentID = 
	(select MAX(crmComments.CommentID)
	from crmComments
	where crmComments.ProjectID=crmProjects.ProjectID)
from crmProjects
where LatestCommentID is null
--done with latestcoment fields

--adding "ShowTagListAsMenu" to "Setttings"
if not exists (select * from syscolumns where id=object_id('crmSettings') and name='ShowTagListAsMenu')
begin
	  ALTER TABLE crmSettings ADD ShowTagListAsMenu bit NOT NULL DEFAULT(0)
end

--adding ReplyToAddress to crmSettings
if not exists (select * from syscolumns where id=object_id('crmSettings') and name='ReplyToAddress')
begin
	ALTER TABLE crmSettings ADD ReplyToAddress varchar(50) NULL
end

--adding "subscribers" tables
IF NOT EXISTS (SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'crmCompanySubscribers') AND type in (N'U'))
BEGIN
	CREATE TABLE crmCompanySubscribers (
		CompanyID int NOT NULL,
		UserID int NOT NULL
	)
	ALTER TABLE crmCompanySubscribers WITH NOCHECK ADD CONSTRAINT [PK_crmCompanySubscribers] PRIMARY KEY CLUSTERED (CompanyID, UserID)

	CREATE TABLE crmContactSubscribers (
		ContactID int NOT NULL,
		UserID int NOT NULL
	)
	ALTER TABLE crmContactSubscribers WITH NOCHECK ADD CONSTRAINT [PK_crmContactSubscribers] PRIMARY KEY CLUSTERED (ContactID, UserID)

	CREATE TABLE crmProjectSubscribers (
		ProjectID int NOT NULL,
		UserID int NOT NULL
	)
	ALTER TABLE crmProjectSubscribers WITH NOCHECK ADD CONSTRAINT [PK_crmProjectSubscribers] PRIMARY KEY CLUSTERED (ProjectID, UserID)
END

--adding "assignedto" column to contacts, companies, projects
if not exists (select * from syscolumns where id=object_id('crmCompanies') and name='AssignedToUserID')
begin
	ALTER TABLE crmCompanies ADD AssignedToUserID int NULL
	ALTER TABLE crmProjects ADD AssignedToUserID int NULL
	ALTER TABLE crmContacts ADD AssignedToUserID int NULL
end
GO

--AutoLoginSharedSecret
if not exists (select * from syscolumns where id=object_id('crmSettings') and name='AutoLoginSharedSecret')
begin
	  ALTER TABLE crmSettings ADD AutoLoginSharedSecret varchar(20) NULL
end

--custom fields
IF NOT EXISTS (SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'crmCustomFields') AND type in (N'U'))
BEGIN
	CREATE TABLE [dbo].[crmCustomFields] (
		[FieldID] [int] IDENTITY (1, 1) NOT NULL PRIMARY KEY,
		[InstanceID] [int] NOT NULL,
		[Type] [int] NOT NULL,
		[FieldName] nvarchar(100) NOT NULL,
		[Mandatory] bit NOT NULL DEFAULT (0),
		[OrderByNumber] int NOT NULL DEFAULT (100),
		UsedForCompanies bit NOT NULL DEFAULT 0,
		UsedForContacts bit NOT NULL DEFAULT 0,
	)
	CREATE TABLE [dbo].[crmCustomFieldCompanyValues] (
		[CompanyID] [int] NOT NULL,
		[FieldID] [int] NOT NULL,
		[Value] sql_variant NOT NULL
	)
	ALTER TABLE [dbo].[crmCustomFieldCompanyValues] WITH NOCHECK ADD 
		CONSTRAINT [PK_crmCustomFieldCompanyValues] PRIMARY KEY CLUSTERED 
		(
			[CompanyID],
			[FieldID]
		)
	CREATE TABLE [dbo].[crmCustomFieldContactValues] (
		ContactID [int] NOT NULL,
		[FieldID] [int] NOT NULL,
		[Value] sql_variant NOT NULL
	)
	ALTER TABLE [dbo].[crmCustomFieldContactValues] WITH NOCHECK ADD 
		CONSTRAINT [PK_crmCustomFieldContactValues] PRIMARY KEY CLUSTERED 
		(
			ContactID,
			[FieldID]
		)
	CREATE TABLE [dbo].[crmCustomFieldOptions] (
		[OptionID] [int] IDENTITY (1, 1) NOT NULL PRIMARY KEY,
		[FieldID] [int] NOT NULL,
		[OptionValue] nvarchar(500) NOT NULL
	)

END
GO

--adding FAX to crmContacts and crmCompanies
if not exists (select * from syscolumns where id=object_id('crmContacts') and name='Fax')
begin
	ALTER TABLE crmContacts ADD Fax varchar(100) NULL
	ALTER TABLE crmCompanies ADD Fax varchar(100) NULL
end

--grid display settings
IF NOT EXISTS (SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'crmUserGridColumns') AND type in (N'U'))
BEGIN
	CREATE TABLE crmUserGridColumns (
		UserID int PRIMARY KEY NOT NULL,
		ShowEmailColumn bit NOT NULL DEFAULT 0,
		ShowPhoneColumn bit NOT NULL DEFAULT 0,
		ShowFaxColumn bit NOT NULL DEFAULT 0,
		ShowAddressColumn bit NOT NULL DEFAULT 0,
		ShowCityColumn bit NOT NULL DEFAULT 0,
		ShowCountryColumn bit NOT NULL DEFAULT 0,
		ShowLastNoteColumn bit NOT NULL DEFAULT 0,
		ShowAssigneeColumn bit NOT NULL DEFAULT 0
	)
END
GO

--project custom fields
if not exists (select * from syscolumns where id=object_id('crmCustomFields') and name='UsedForProjects')
begin
	ALTER TABLE crmCustomFields ADD UsedForProjects bit NOT NULL DEFAULT 0
	
	CREATE TABLE [dbo].[crmCustomFieldProjectValues] (
		[ProjectID] [int] NOT NULL,
		[FieldID] [int] NOT NULL,
		[Value] sql_variant NOT NULL
	)
	ALTER TABLE [dbo].[crmCustomFieldProjectValues] WITH NOCHECK ADD 
		CONSTRAINT [PK_crmCustomFieldProjectValues] PRIMARY KEY CLUSTERED 
		(
			[ProjectID],
			[FieldID]
		)
end
GO

--if crmInstances - rename
IF EXISTS (SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'crmInstances') AND type in (N'U'))
begin
	exec sp_rename 'crmInstances', 'Instances'
end

--"Domain" for instances
if not exists (select * from syscolumns where id=object_id('Instances') and name='CustomDomain')
begin
	ALTER TABLE Instances ADD CustomDomain varchar(100) NULL
end
GO

--project tags
--custom fields
IF NOT EXISTS (SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'crmProjectTags') AND type in (N'U'))
BEGIN
	CREATE TABLE [dbo].[crmProjectTags] (
		TagID int NOT NULL,
		ProjectID int NOT NULL
	)
	ALTER TABLE [dbo].[crmProjectTags] WITH NOCHECK ADD CONSTRAINT [PK_crmProjectTags] PRIMARY KEY CLUSTERED (
		TagID,
		ProjectID
	)
END
GO

--adding "title" to crmSettings
if not exists (select * from syscolumns where id=object_id('crmSettings') and name='Title')
begin
	ALTER TABLE crmSettings ADD Title varchar(500) NOT NULL DEFAULT ''
end
GO
--moving from crminatces if any
if exists (select * from syscolumns where id=object_id('crmSettings') and name='Description')
begin
	declare @sql nvarchar(max)
	set @sql = N'update crmSettings SET crmSettings.Title = Instances.Description
	from Instances inner join crmSettings ON Instances.InstanceID=crmSettings.InstanceID'
	exec sp_executesql @sql

	ALTER TABLE Instances DROP COLUMN Description
end

--instance column for tags (required for autocomplete) (this script is incompatible with multi-instance version!!!!)
if not exists (select * from syscolumns where id=object_id('crmTags') and name='InstanceID')
begin
	ALTER TABLE crmTags ADD InstanceID int NOT NULL DEFAULT 0
end
GO

--imap
if not exists (select * from syscolumns where id=object_id('crmSettings') and name='MailCheckerIsImap')
begin
	ALTER TABLE crmSettings ADD MailCheckerIsImap bit NOT NULL DEFAULT (0)
end

--"AssignedToUserID" for tasks
if not exists (select * from syscolumns where id=object_id('crmTasks') and name='AssignedToUserID')
begin
	ALTER TABLE crmTasks ADD AssignedToUserID int NULL
end

if not exists (select * from syscolumns where id=object_id('crmSettings') and name='HDRootUrl')
begin
	ALTER TABLE crmSettings ADD HDRootUrl varchar(1000) not null DEFAULT ''
	ALTER TABLE crmSettings ADD HDSharedKey varchar(255) not null DEFAULT ''
end

--"Value" for projects
if not exists (select * from syscolumns where id=object_id('crmProjects') and name='Value')
begin
	ALTER TABLE crmProjects ADD Value money NULL
	ALTER TABLE crmProjects ADD ValueCurrency char(3) NOT NULL DEFAULT 'USD'
end

--custom fields grid settings
if not exists (select * from syscolumns where id=object_id('crmUserGridColumns') and name='CustomFieldsToShowInContacts')
begin
	ALTER TABLE crmUserGridColumns ADD CustomFieldsToShowInContacts varchar(100) NOT NULL DEFAULT ''
	ALTER TABLE crmUserGridColumns ADD CustomFieldsToShowInCompanies varchar(100) NOT NULL DEFAULT ''
end

--"Disabled" for users
if not exists (select * from syscolumns where id=object_id('crmUsers') and name='Disabled')
begin
	ALTER TABLE crmUsers ADD [Disabled] bit not null default 0
end

--imap
if not exists (select * from syscolumns where id=object_id('crmSettings') and name='ShowEntitiesToSubscribersOnly')
begin
	ALTER TABLE crmSettings ADD ShowEntitiesToSubscribersOnly bit NOT NULL DEFAULT (0)
end

--"Disabled" for users
if not exists (select * from syscolumns where id=object_id('crmUsers') and name='EmailSignature')
begin
	ALTER TABLE crmUsers ADD EmailSignature nvarchar(1000) NULL
end

--Task comments
IF NOT EXISTS (SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'crmTaskComments') AND type in (N'U'))
BEGIN
	CREATE TABLE [dbo].[crmTaskComments](
		[CommentID] [int] IDENTITY(1,1) PRIMARY KEY NOT NULL,
		[TaskID] [int] NOT NULL,
		[UserID] [int] NOT NULL,
		[Body] [nvarchar](500) NOT NULL,
		[Date] [datetime] NOT NULL DEFAULT (getdate())
	)
end

--Updating default color from the old ones to the new ones, not changing if user has custom colors
IF EXISTS (SELECT * FROM crmSettings WHERE HeaderBGColor = '000000' AND InstanceID = 0)begin
UPDATE crmSettings SET HeaderBGColor ='34383E' WHERE InstanceID = 0
end

IF EXISTS (SELECT * FROM crmSettings WHERE MenuBarBGColor = 'FF7700' AND InstanceID = 0)begin
UPDATE crmSettings SET MenuBarBGColor ='4C5B6B' WHERE InstanceID = 0
end

if not exists (select * from syscolumns where id=object_id('crmSettings') and name='MailCheckerAllowUnregisteredContacts')
begin
	ALTER TABLE crmSettings ADD MailCheckerAllowUnregisteredContacts bit NOT NULL DEFAULT (0)
end

if not exists (select * from syscolumns where id=object_id('crmUserGridColumns') and name='ShowStateColumn')
begin
	ALTER TABLE crmUserGridColumns ADD ShowStateColumn bit NOT NULL DEFAULT (0)
end

--GoogleDrivePath
if not exists (select * from syscolumns where id=object_id('crmFileAttachments') and name='GoogleDriveUrl')
begin
	ALTER TABLE crmFileAttachments ADD GoogleDriveUrl varchar(255) NULL
end

--make FileData column nullable
ALTER TABLE crmFileAttachments ALTER COLUMN FileData [image] NULL

--Last Login date
if not exists (select * from syscolumns where id=object_id('crmUsers') and name='LastSeen')
begin
	ALTER TABLE crmUsers ADD LastSeen datetime NULL
end

--Last Login date
if not exists (select * from syscolumns where id=object_id('crmUsers') and name='IPAddress')
begin
	ALTER TABLE crmUsers ADD IPAddress varchar(50) NULL
end

go

--InstanceID in comments (denormalize for performance)
if not exists (select * from syscolumns where id=object_id('crmComments') and name='InstanceID')
begin
	ALTER TABLE crmComments ADD InstanceID int NULL
	
	declare @sql nvarchar(max)
	set @sql = N'UPDATE crmComments SET InstanceID=ISNULL(crmContacts.InstanceID, ISNULL(crmCompanies.InstanceID, ISNULL(crmProjects.InstanceID, -1)))
		FROM crmComments
		LEFT JOIN crmContacts ON crmComments.ContactID=crmContacts.ContactID
		LEFT JOIN crmCompanies ON crmComments.CompanyID=crmCompanies.CompanyID
		LEFT JOIN crmProjects ON crmComments.ProjectID=crmProjects.ProjectID'
	exec sp_executesql @sql
	
	ALTER TABLE crmComments ALTER COLUMN InstanceID int NOT NULL
end